import{S as pt,i as ut,s as mt,e as l,k as u,w as W,t as n,M as ct,c as r,d as t,m,a as f,x as V,h as s,b as p,N as ht,G as o,g as a,y as B,L as dt,q as F,o as L,B as Y,v as gt}from"../../chunks/vendor-hf-doc-builder.js";import{I as bt}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as _e}from"../../chunks/CodeBlock-hf-doc-builder.js";import{D as yt}from"../../chunks/DocNotebookDropdown-hf-doc-builder.js";function _t(Re){let g,O,b,y,R,P,we,X,ve,H,k,K,I,$e,ee,_,Pe,G,ke,Ee,te,c,je,U,Te,Me,E,Ze,De,oe,h,xe,J,Ie,Ge,j,Ue,Je,ie,T,ae,w,Ce,C,qe,Ne,ne,M,se,v,Se,z,Ae,We,le,Z,re,$,Ve,D,Q,Be,Fe,fe,q,Le,pe,x,ue,N,Ye,me,d,Xe,ce;return P=new bt({}),k=new yt({props:{classNames:"absolute z-10 right-0 top-0",options:[{label:"Mixed",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/conditional_image_generation.ipynb"},{label:"PyTorch",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/pytorch/conditional_image_generation.ipynb"},{label:"TensorFlow",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/tensorflow/conditional_image_generation.ipynb"},{label:"Mixed",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/conditional_image_generation.ipynb"},{label:"PyTorch",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/pytorch/conditional_image_generation.ipynb"},{label:"TensorFlow",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/tensorflow/conditional_image_generation.ipynb"}]}}),T=new _e({props:{code:"ZnJvbSUyMGRpZmZ1c2VycyUyMGltcG9ydCUyMERpZmZ1c2lvblBpcGVsaW5lJTBBJTBBZ2VuZXJhdG9yJTIwJTNEJTIwRGlmZnVzaW9uUGlwZWxpbmUuZnJvbV9wcmV0cmFpbmVkKCUyMkNvbXBWaXMlMkZsZG0tdGV4dDJpbS1sYXJnZS0yNTYlMjIp",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>generator = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;CompVis/ldm-text2im-large-256&quot;</span>)`}}),M=new _e({props:{code:"Z2VuZXJhdG9yLnRvKCUyMmN1ZGElMjIp",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>generator.to(<span class="hljs-string">&quot;cuda&quot;</span>)'}}),Z=new _e({props:{code:"aW1hZ2UlMjAlM0QlMjBnZW5lcmF0b3IoJTIyQW4lMjBpbWFnZSUyMG9mJTIwYSUyMHNxdWlycmVsJTIwaW4lMjBQaWNhc3NvJTIwc3R5bGUlMjIpLmltYWdlcyU1QjAlNUQ=",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>image = generator(<span class="hljs-string">&quot;An image of a squirrel in Picasso style&quot;</span>).images[<span class="hljs-number">0</span>]'}}),x=new _e({props:{code:"aW1hZ2Uuc2F2ZSglMjJpbWFnZV9vZl9zcXVpcnJlbF9wYWludGluZy5wbmclMjIp",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>image.save(<span class="hljs-string">&quot;image_of_squirrel_painting.png&quot;</span>)'}}),{c(){g=l("meta"),O=u(),b=l("h1"),y=l("a"),R=l("span"),W(P.$$.fragment),we=u(),X=l("span"),ve=n("Conditional image generation"),H=u(),W(k.$$.fragment),K=u(),I=l("p"),$e=n("Conditional image generation allows you to generate images from a text prompt. The text is converted into embeddings which are used to condition the model to generate an image from noise."),ee=u(),_=l("p"),Pe=n("The "),G=l("a"),ke=n("DiffusionPipeline"),Ee=n(" is the easiest way to use a pre-trained diffusion system for inference."),te=u(),c=l("p"),je=n("Start by creating an instance of "),U=l("a"),Te=n("DiffusionPipeline"),Me=n(" and specify which pipeline "),E=l("a"),Ze=n("checkpoint"),De=n(" you would like to download."),oe=u(),h=l("p"),xe=n("In this guide, you\u2019ll use "),J=l("a"),Ie=n("DiffusionPipeline"),Ge=n(" for text-to-image generation with "),j=l("a"),Ue=n("Latent Diffusion"),Je=n(":"),ie=u(),W(T.$$.fragment),ae=u(),w=l("p"),Ce=n("The "),C=l("a"),qe=n("DiffusionPipeline"),Ne=n(` downloads and caches all modeling, tokenization, and scheduling components.
Because the model consists of roughly 1.4 billion parameters, we strongly recommend running it on a GPU.
You can move the generator object to a GPU, just like you would in PyTorch:`),ne=u(),W(M.$$.fragment),se=u(),v=l("p"),Se=n("Now you can use the "),z=l("code"),Ae=n("generator"),We=n(" on your text prompt:"),le=u(),W(Z.$$.fragment),re=u(),$=l("p"),Ve=n("The output is by default wrapped into a "),D=l("a"),Q=l("code"),Be=n("PIL.Image"),Fe=n(" object."),fe=u(),q=l("p"),Le=n("You can save the image by calling:"),pe=u(),W(x.$$.fragment),ue=u(),N=l("p"),Ye=n("Try out the Spaces below, and feel free to play around with the guidance scale parameter to see how it affects the image quality!"),me=u(),d=l("iframe"),this.h()},l(e){const i=ct('[data-svelte="svelte-1phssyn"]',document.head);g=r(i,"META",{name:!0,content:!0}),i.forEach(t),O=m(e),b=r(e,"H1",{class:!0});var he=f(b);y=r(he,"A",{id:!0,class:!0,href:!0});var ze=f(y);R=r(ze,"SPAN",{});var Qe=f(R);V(P.$$.fragment,Qe),Qe.forEach(t),ze.forEach(t),we=m(he),X=r(he,"SPAN",{});var Oe=f(X);ve=s(Oe,"Conditional image generation"),Oe.forEach(t),he.forEach(t),H=m(e),V(k.$$.fragment,e),K=m(e),I=r(e,"P",{});var He=f(I);$e=s(He,"Conditional image generation allows you to generate images from a text prompt. The text is converted into embeddings which are used to condition the model to generate an image from noise."),He.forEach(t),ee=m(e),_=r(e,"P",{});var de=f(_);Pe=s(de,"The "),G=r(de,"A",{href:!0});var Ke=f(G);ke=s(Ke,"DiffusionPipeline"),Ke.forEach(t),Ee=s(de," is the easiest way to use a pre-trained diffusion system for inference."),de.forEach(t),te=m(e),c=r(e,"P",{});var S=f(c);je=s(S,"Start by creating an instance of "),U=r(S,"A",{href:!0});var et=f(U);Te=s(et,"DiffusionPipeline"),et.forEach(t),Me=s(S," and specify which pipeline "),E=r(S,"A",{href:!0,rel:!0});var tt=f(E);Ze=s(tt,"checkpoint"),tt.forEach(t),De=s(S," you would like to download."),S.forEach(t),oe=m(e),h=r(e,"P",{});var A=f(h);xe=s(A,"In this guide, you\u2019ll use "),J=r(A,"A",{href:!0});var ot=f(J);Ie=s(ot,"DiffusionPipeline"),ot.forEach(t),Ge=s(A," for text-to-image generation with "),j=r(A,"A",{href:!0,rel:!0});var it=f(j);Ue=s(it,"Latent Diffusion"),it.forEach(t),Je=s(A,":"),A.forEach(t),ie=m(e),V(T.$$.fragment,e),ae=m(e),w=r(e,"P",{});var ge=f(w);Ce=s(ge,"The "),C=r(ge,"A",{href:!0});var at=f(C);qe=s(at,"DiffusionPipeline"),at.forEach(t),Ne=s(ge,` downloads and caches all modeling, tokenization, and scheduling components.
Because the model consists of roughly 1.4 billion parameters, we strongly recommend running it on a GPU.
You can move the generator object to a GPU, just like you would in PyTorch:`),ge.forEach(t),ne=m(e),V(M.$$.fragment,e),se=m(e),v=r(e,"P",{});var be=f(v);Se=s(be,"Now you can use the "),z=r(be,"CODE",{});var nt=f(z);Ae=s(nt,"generator"),nt.forEach(t),We=s(be," on your text prompt:"),be.forEach(t),le=m(e),V(Z.$$.fragment,e),re=m(e),$=r(e,"P",{});var ye=f($);Ve=s(ye,"The output is by default wrapped into a "),D=r(ye,"A",{href:!0,rel:!0});var st=f(D);Q=r(st,"CODE",{});var lt=f(Q);Be=s(lt,"PIL.Image"),lt.forEach(t),st.forEach(t),Fe=s(ye," object."),ye.forEach(t),fe=m(e),q=r(e,"P",{});var rt=f(q);Le=s(rt,"You can save the image by calling:"),rt.forEach(t),pe=m(e),V(x.$$.fragment,e),ue=m(e),N=r(e,"P",{});var ft=f(N);Ye=s(ft,"Try out the Spaces below, and feel free to play around with the guidance scale parameter to see how it affects the image quality!"),ft.forEach(t),me=m(e),d=r(e,"IFRAME",{src:!0,frameborder:!0,width:!0,height:!0}),f(d).forEach(t),this.h()},h(){p(g,"name","hf:doc:metadata"),p(g,"content",JSON.stringify(wt)),p(y,"id","conditional-image-generation"),p(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(y,"href","#conditional-image-generation"),p(b,"class","relative group"),p(G,"href","/docs/diffusers/pr_24/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),p(U,"href","/docs/diffusers/pr_24/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),p(E,"href","https://huggingface.co/models?library=diffusers&sort=downloads"),p(E,"rel","nofollow"),p(J,"href","/docs/diffusers/pr_24/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),p(j,"href","https://huggingface.co/CompVis/ldm-text2im-large-256"),p(j,"rel","nofollow"),p(C,"href","/docs/diffusers/pr_24/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),p(D,"href","https://pillow.readthedocs.io/en/stable/reference/Image.html?highlight=image#the-image-class"),p(D,"rel","nofollow"),ht(d.src,Xe="https://stabilityai-stable-diffusion.hf.space")||p(d,"src",Xe),p(d,"frameborder","0"),p(d,"width","850"),p(d,"height","500")},m(e,i){o(document.head,g),a(e,O,i),a(e,b,i),o(b,y),o(y,R),B(P,R,null),o(b,we),o(b,X),o(X,ve),a(e,H,i),B(k,e,i),a(e,K,i),a(e,I,i),o(I,$e),a(e,ee,i),a(e,_,i),o(_,Pe),o(_,G),o(G,ke),o(_,Ee),a(e,te,i),a(e,c,i),o(c,je),o(c,U),o(U,Te),o(c,Me),o(c,E),o(E,Ze),o(c,De),a(e,oe,i),a(e,h,i),o(h,xe),o(h,J),o(J,Ie),o(h,Ge),o(h,j),o(j,Ue),o(h,Je),a(e,ie,i),B(T,e,i),a(e,ae,i),a(e,w,i),o(w,Ce),o(w,C),o(C,qe),o(w,Ne),a(e,ne,i),B(M,e,i),a(e,se,i),a(e,v,i),o(v,Se),o(v,z),o(z,Ae),o(v,We),a(e,le,i),B(Z,e,i),a(e,re,i),a(e,$,i),o($,Ve),o($,D),o(D,Q),o(Q,Be),o($,Fe),a(e,fe,i),a(e,q,i),o(q,Le),a(e,pe,i),B(x,e,i),a(e,ue,i),a(e,N,i),o(N,Ye),a(e,me,i),a(e,d,i),ce=!0},p:dt,i(e){ce||(F(P.$$.fragment,e),F(k.$$.fragment,e),F(T.$$.fragment,e),F(M.$$.fragment,e),F(Z.$$.fragment,e),F(x.$$.fragment,e),ce=!0)},o(e){L(P.$$.fragment,e),L(k.$$.fragment,e),L(T.$$.fragment,e),L(M.$$.fragment,e),L(Z.$$.fragment,e),L(x.$$.fragment,e),ce=!1},d(e){t(g),e&&t(O),e&&t(b),Y(P),e&&t(H),Y(k,e),e&&t(K),e&&t(I),e&&t(ee),e&&t(_),e&&t(te),e&&t(c),e&&t(oe),e&&t(h),e&&t(ie),Y(T,e),e&&t(ae),e&&t(w),e&&t(ne),Y(M,e),e&&t(se),e&&t(v),e&&t(le),Y(Z,e),e&&t(re),e&&t($),e&&t(fe),e&&t(q),e&&t(pe),Y(x,e),e&&t(ue),e&&t(N),e&&t(me),e&&t(d)}}}const wt={local:"conditional-image-generation",title:"Conditional image generation"};function vt(Re){return gt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class jt extends pt{constructor(g){super();ut(this,g,vt,_t,mt,{})}}export{jt as default,wt as metadata};
